EDIT - bug #5710

Changing the database connection must reset all caches
04/13/2016 09:37 PM - Andreas Mller

Status: In Progress Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 20%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.46

Severity: critical Found in Version:

Description

In standalone the caches for static methods were reset during creation of the spring context. This does not take place anymore
therefore we need to reload or empty all caches.

This is especially the second level cache (currently called CdmServiceCacher) for terms and vocabularies and all static methods
(e.g. in Rank and NomenclaturalStatusType).

This is a critical issue as it is a regression and it may create incorrect or even invalid data.
Probably duplicated by #5512 and #5539

In my case it created an alternative name instead of a later homonym relationship.

Associated revisions

Revision d68c7480 - 04/21/2016 08:48 AM - Katja Luther

fix for #5710 reset the terms when changing the datasource in remoting

Revision fdb1753a - 06/10/2020 12:48 PM - Andreas Miiller

ref #5710 run term reset on all Term classes

Revision 9d700cfc - 07/11/2020 10:50 AM - Andreas Miiller

ref #5710 add reset to TermManager after reconnect

History

#1 - 04/14/2016 11:13 AM - Katja Luther
r27708 should fix this.

#2 - 04/21/2016 08:55 AM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from K.luther - to Andreas Mtiller

reset the terms before connecting to a new datasource see r27765

#3 - 06/27/2016 01:00 PM - Andreas Miuller

In Mexico Rubiaceae | observered that | added NamedArealLevel und Type to existing areas but they resulted in wrong ID in the database. This very
much reminded me to this ticket. | am not 100% sure if | added level and type after changing the database connection but definetely we need to test
this ticket intensively before closing.

#4 - 06/10/2020 12:54 PM - Andreas Miiller

- Description updated

- Status changed from Resolved to Feedback

- Target version changed from Release 4.0 to Release 5.18

- Private changed from Yes to No

This is not yet fixed as we watched in the past multiple times that switching between instances created serious problems as terms were referencing
wrong ids after the switch.

| did now improve the first reset() functionality (reset for static methods) to include not only the Rank and NomenclaturalStatusType class but all
managed term classes.

We need to check how far this solves the problem.

However, | guess that also the term term cache(s) (terms and vocabularies) need to be fully emptied/replaced. | can't see that this is already done in
the code, but maybe | only look at the wrong place.

#5 - 06/30/2020 03:28 PM - Andreas Miuller

- Status changed from Feedback to In Progress

#6 - 07/11/2020 10:32 AM - Andreas Miiller

- Description updated

It looks like emptying the cache is done in CdmStoreConnector in this line

CdmStore.setInstance (applicationController, cdmSource);

Which calls

CdmApplicationState.setCdmServiceCacher (new CdmServiceCacher());

and calling the construtor of CdmServiceCacher calls setup() in this class which then calls
DefinedTermBase.setCacher (this);
CdmTransientEntityCacher.setPermanentCacher (this);
//TermServiceRequestExecutor.setDefaultCacher (this);
RemoteInvocationTermCacher.setDefaultCacher (this);

and resets the cache in DefinedTermBase (and others) this way

#7 - 07/11/2020 10:52 AM - Andreas Miiller

- Status changed from In Progress to Resolved

- % Done changed from 0 to 40

There is a cache also in TermManager !!!
This is currently not emptied when connecting to a new datasource.

| added TermManager.reset() with commit 9d700cfc23f6e13931

#8 - 07/11/2020 10:52 AM - Andreas Miiller

This needs to be checked if this fully solves the problem

#11 - 07/14/2020 09:23 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther

Can you please test the results of the latest changes and see if the problem still exists by testing with data related to different term types (not only
Rank and NomenclaturalStatusType).
After testing please return back to me.

#12 - 08/17/2020 10:25 AM - Katja Luther

Hast Du Beispiel Datenbanken mit denen ich testen kann?

#13 - 08/17/2020 02:48 PM - Andreas Miiller

Nicht wirklich, es sollte aber Uberall dort funktionieren, wo mdglichst viele Terme sich in ihrer ID unterscheiden, weil spater mal ein Term in einem
"frihen" Vokabular hinzugefiigt wurde. Wenn man das Arbeiten und editieren mit solchen sich ID-seitig unterscheidenden Termen nach einem
Datasource wechsel testet, trat friher oft ein Fehler auf (z.B. ein falscher Rang wurde verwendet oder so). Ein klares Kochrezept habe ich aber noch
nicht.

#14 - 08/18/2020 09:17 AM - Katja Luther
- Status changed from Resolved to Feedback

- Assignee changed from Katja Luther to Andreas Mdiller
Testing between caryophyllales_spp, palmae and algaterra on test, after adding a new nomenclatural status in algaterra results in:

last remote method

last remote request client time
last remote request response header time
2020-08-18T09:03:37.662

client error time
login admin

editor version

server
schema version
os
Java : 1.8.0_171

test.e-taxonomy.eu
SodS.20
Windows 7 6.1 amdé64

0.20200611

5.17.0.202008132255
(edit-test)

org.hibernate.ObjectNotFoundException:
omenclaturalStatusType#845]
at org.hibernate.boot.internal.StandardEntityNotFoundDelegate.handleEntityNotFound (StandardEntityNotFoundD

elegate. java:28)
at org.hibernate
at org.hibernate
at
at
at

org.hibernate
org.hibernate

ralStatusType_S$S$_7Jvst534_5b. java)
at eu.etaxonomy.cdm.strategy.cache.name.TaxonNameDefaultCacheStrategy.getNomStatusTags (TaxonNameDefaultCac

heStrategy.java:349)

at eu.etaxonomy.cdm.

rategy.java:106)

Tue,

/ algaterra

No row with the given identifier exists:

http://test.e-taxonomy.eu:80/cdmserver/algaterra/remoting/taxonnode.service
2020-08-18T09:03:37.504
18 Aug 2020 09:03:43 GMT

[eu.etaxonomy.cdm.model.name.N

.proxy.AbstractLazyInitializer.checkTargetState (AbstractLazyInitializer. java:242)
.proxy.AbstractLazyInitializer.initialize (AbstractLazyInitializer.java:159)
.proxy.AbstractLazyInitializer.getImplementation (AbstractLazyInitializer.java:266)
.proxy.pojo.javassist.JavassistLazyInitializer.invoke (JavassistLazyInitializer. java:68)
eu.etaxonomy.cdm.model.name.NomenclaturalStatusType_$S$_Jjvst534_5b.getPreferredRepresentation (Nomenclatu

strategy.cache.taxon.TaxonBaseDefaultCacheStrategy.getNameTags (TaxonBaseDefaultCacheSt

at eu.etaxonomy.cdm.strategy.cache.taxon.TaxonBaseDefaultCacheStrategy.getTaggedTitle (TaxonBaseDefaultCach
eStrategy.java:65)

at eu.etaxonomy.cdm.model.taxon.TaxonBase.getTaggedTitle (TaxonBase.java:231)

at eu.etaxonomy.cdm.persistence.dao.initializer.TitleAndNameCacheAutoInitializer.initialize (TitleAndNameCa
cheAutoInitializer. java:84)

at eu.etaxonomy.cdm.persistence.dao.initializer.TitleAndNameCacheAutoInitializer.initialize (TitleAndNameCa
cheAutolInitializer.java:32)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.autoinitializeBean (AdvancedBeanIni
tializer.java:382)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.bulkLoadLazyBeans (AdvancedBeanInit
ializer.java:473)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.bulkLoadLazies (AdvancedBeanInitial
izer.java:434)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNodeNoWildcard (AdvancedB
eanInitializer. java:245)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNode (AdvancedBeanInitial
izer.java:126)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNodeRecursive (AdvancedBe
anInitializer.java:106)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNodeRecursive (AdvancedBe
anInitializer.java:108)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeAll (AdvancedBeanInitiali
zer.java:86)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initialize (AdvancedBeanInitializer
.Jjava:58)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.load (CdmEntityDaoBase. java:786)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.load (VersionableDaoBase.java:113)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.load (VersionableDaoBase. java:106)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.load (VersionableDaoBase. java:36)

at eu.etaxonomy.cdm.api.service.ServiceBase.load (ServiceBase.java:208)

at eu.etaxonomy.cdm.api.service.ServiceBase.load (ServiceBase. java:42)

at sun.reflect.NativeMethodAccessorImpl.invoke0 (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodInvocation
.java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15
7)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (TransactionI
nterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio

nAspectSupport. java:281)

at org.springframework.
6)

at org.springframework.
9)

at org.springframework.
transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor. java:9
aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

aop. framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy. java:208)
.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:316
access.intercept.FilterSecurityInterceptor.invoke (FilterSecurityInterc
access.intercept.FilterSecurityInterceptor.doFilter (FilterSecurityInte
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
access.ExceptionTranslationFilter.doFilter (ExceptionTranslationFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
.session.SessionManagementFilter.doFilter (SessionManagementFilter. java:
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
servletapi.SecurityContextHolderAwareRequestFilter.doFilter (SecurityCo
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
savedrequest .RequestCacheAwareFilter.doFilter (RequestCacheAwareFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

.authentication.www.BasicAuthenticationFilter.doFilterInternal (BasicAut

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilter. java:120)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330

security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWriterFilter. java:64)
web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330
at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFilter (SecurityContextPersi
stenceFilter.java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter.doFilterInterna

1 (WebAsyncManagerIntegrationFilter. java:53)
web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy.java:346)
web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy.java:262)
eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1604)
ReservedThreadExecutor$ReservedThread. run (ReservedThreadExecutor. java: 388

QueuedThreadPool.runJob (QueuedThreadPool. java:806)
java.lang.Thread.run (Thread. java:748)
9)
at
at
at
at
at
at
at
at
at
at

org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

com.sun.proxy.S$Proxy47.
.taxeditor.

eu.
eu.
eu
eu
eu.
eu

etaxonomy
etaxonomy

.etaxonomy
.etaxonomy

etaxonomy

.etaxonomy
editor.
editor.
editor.
editor.

load (Unknown Source)

ed.TaxonEditorInputE4.initForTaxonNode (TaxonEditorInputE4. java:124)
e4.TaxonEditorInputE4.<init> (TaxonEditorInputE4. java:113)
ed.TaxonEditorInputE4.NewInstance (TaxonEditorInputE4. java:262)
EditorUtil.openTaxonNodeE4 (EditorUtil. java:194)

navigation.NavigationUtil.openEditor (NavigationUtil. java:70)
navigation.navigator.e4d.TaxonNavigatorE4.lambda$0 (TaxonNavigatorE4. java:179)

org.eclipse.jface.viewers.StructuredViewer$l.run (StructuredViewer. java:833)
org.eclipse.core.runtime.SafeRunner.run (SafeRunner. java:42)
at org.eclipse.ui.internal.JFaceUtil$1l.run (JFaceUtil. java:50)

at org.eclipse.jface.util.SafeRunnable.run (SafeRunnable. java:173)

at org.eclipse.jface.viewers.StructuredViewer.fireDoubleClick (StructuredViewer. java:830)

at org.eclipse.jface.viewers.AbstractTreeViewer.handleDoubleSelect (AbstractTreeViewer. java:1470)
at org.eclipse.jface.viewers.StructuredvViewer$4.widgetDefaultSelected (StructuredvViewer. java:1264)
at org.eclipse.jface.util.OpenStrategy.fireDefaultSelectionEvent (OpenStrategy.java:252)

at org.eclipse.jface.util.OpenStrategy.access$0 (OpenStrategy.java:249)

at org.eclipse.jface.util.OpenStrategy$l.handleEvent (OpenStrategy.java:311)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget.java:1079)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)

at org.eclipse.ed4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:1121)
at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1022)
at org.eclipse.e4d4.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:20)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication(EclipseAppLauncher. java:134

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher.java:104)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (Unknown Source)

at java.lang.reflect.Method.invoke (Unknown Source)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main.java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)

#15 - 08/19/2020 12:37 PM - Andreas Miiller
- Target version changed from Release 5.18 to Release 5.19

- % Done changed from 40 to 20

Thank you for testing. So it still does not work and | will move it forward to the next milestone.

#16 - 08/19/2020 08:46 PM - Andreas Miiller

- Target version changed from Release 5.19 to Release 5.18

#17 - 11/09/2020 01:23 PM - Andreas Miiller

- Target version changed from Release 5.18 to Release 5.19

#18 - 01/27/2021 04:51 PM - Andreas Miiller
- Status changed from Feedback to In Progress

- Target version changed from Release 5.19 to Release 5.21

#19 - 03/10/2021 02:35 PM - Andreas Miiller

- Target version changed from Release 5.21 to Release 5.22

#20 - 04/16/2021 10:16 PM - Andreas Miiller

- Target version changed from Release 5.22 to Release 5.46
